> For the complete documentation index, see [llms.txt](https://liquiidio.gitbook.io/unity-plugin-suite/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://liquiidio.gitbook.io/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces/eossharp-core-interfaces-isignprovider.md).

# ISignProvider

Signature provider Interface to delegate multiple signing implementations.

## Summary

| Members                                                                                                                                                                                                                                  | Descriptions                                       |
| ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------- |
| `public Task< IEnumerable< string > >` [`GetAvailableKeys`](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)`()`                                                                                         | Get available public keys from signature provider. |
| `public Task< IEnumerable< string > >` [`Sign`](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)`(string chainId, IEnumerable< string > requiredKeys, byte[] signBytes, IEnumerable< string > abiNames)` | Sign bytes using the signature provider.           |
| `public string` [`Sign`](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)`(string chainId, byte[] signBytes)`                                                                                            | Sign bytes using the signature provider.           |
| `public Dictionary< string, string >` [`Sign`](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)`()`                                                                                                      |                                                    |

## Members

**`public Task< IEnumerable< string > >`** [**`GetAvailableKeys`**](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)**`()`**

Get available public keys from signature provider.

#### Returns

List of public keys

**`public Task< IEnumerable< string > >`** [**`Sign`**](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)**`(string chainId, IEnumerable< string > requiredKeys, byte[] signBytes, IEnumerable< string > abiNames)`**

Sign bytes using the signature provider.

#### Parameters

* `chainId` EOSIO Chain id
* `requiredKeys` required public keys for signing this bytes
* `signBytes` signature bytes
* `abiNames` abi contract names to get abi information from

#### Returns

List of signatures per required keys

**`public string`** [**`Sign`**](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)**`(string chainId, byte[] signBytes)`**

Sign bytes using the signature provider.

#### Parameters

* `key` key used for signing
* `signBytes` signature bytes

#### Returns

List of signatures per required keys

**`public Dictionary< string, string >`** [**`Sign`**](/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces.md)**`()`**


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://liquiidio.gitbook.io/unity-plugin-suite/eossharp/api-docs/eossharp-core/eossharp-core-interfaces/eossharp-core-interfaces-isignprovider.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
